import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{readFile}from"fs";import{AuthenticationError}from"../../errors";import{credentialLogger}from"../../util/logging";import{mapScopesToResource}from"./utils";import{azureArcAPIVersion}from"./constants";const msiName="ManagedIdentityCredential - Azure Arc MSI",logger=credentialLogger(msiName);function prepareRequestOptions(e,t,r){const n=mapScopesToResource(e);if(!n)throw new Error(`${msiName}: Multiple scopes are not supported.`);const i={resource:n,"api-version":azureArcAPIVersion};if(t&&(i.client_id=t),r&&(i.msi_res_id=r),!process.env.IDENTITY_ENDPOINT)throw new Error(`${msiName}: Missing environment variable: IDENTITY_ENDPOINT`);const s=new URLSearchParams(i);return createPipelineRequest({url:`${process.env.IDENTITY_ENDPOINT}?${s.toString()}`,method:"GET",headers:createHttpHeaders({Accept:"application/json",Metadata:"true"})})}function readFileAsync(e,t){return new Promise(((r,n)=>readFile(e,t,((e,t)=>{e&&n(e),r(t)}))))}async function filePathRequest(e,t){const r=await e.sendRequest(createPipelineRequest(t));if(401!==r.status){let e="";throw r.bodyAsText&&(e=` Response: ${r.bodyAsText}`),new AuthenticationError(r.status,`${msiName}: To authenticate with Azure Arc MSI, status code 401 is expected on the first request. ${e}`)}const n=r.headers.get("www-authenticate")||"";try{return n.split("=").slice(1)[0]}catch(e){throw Error(`Invalid www-authenticate header format: ${n}`)}}export const arcMsi={name:"arc",async isAvailable({scopes:e}){if(!mapScopesToResource(e))return logger.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const t=Boolean(process.env.IMDS_ENDPOINT&&process.env.IDENTITY_ENDPOINT);return t||logger.info(`${msiName}: The environment variables needed are: IMDS_ENDPOINT and IDENTITY_ENDPOINT`),t},async getToken(e,t={}){var r;const{identityClient:n,scopes:i,clientId:s,resourceId:o}=e;s&&logger.warning(`${msiName}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),o&&logger.warning(`${msiName}: user defined managed Identity by resource Id is not supported. Argument resourceId will be ignored.`),logger.info(`${msiName}: Authenticating.`);const a=Object.assign(Object.assign({disableJsonStringifyOnBody:!0,deserializationMapper:void 0,abortSignal:t.abortSignal},prepareRequestOptions(i,s,o)),{allowInsecureConnection:!0}),c=await filePathRequest(n,a);if(!c)throw new Error(`${msiName}: Failed to find the token file.`);const u=await readFileAsync(c,{encoding:"utf-8"});null===(r=a.headers)||void 0===r||r.set("Authorization",`Basic ${u}`);const l=createPipelineRequest(Object.assign(Object.assign({},a),{allowInsecureConnection:!0})),d=await n.sendTokenRequest(l);return d&&d.accessToken||null}};