import*as msalNode from"@azure/msal-node";import{MsalNode}from"./msalNodeCommon";import{credentialLogger,formatError,formatSuccess}from"../../util/logging";import{CredentialUnavailableError}from"../../errors";import http from"http";import{msalToPublic}from"../utils";import open from"open";import stoppable from"stoppable";export const interactiveBrowserMockable={open:open};export class MsalOpenBrowser extends MsalNode{constructor(e){super(e),this.logger=credentialLogger("Node.js MSAL Open Browser"),this.redirectUri=e.redirectUri,this.loginHint=e.loginHint;const r=new URL(this.redirectUri);this.port=parseInt(r.port),isNaN(this.port)&&(this.port=80),this.hostname=r.hostname}async acquireTokenByCode(e,r){return this.getApp("public",r).acquireTokenByCode(e)}doGetToken(e,r){return new Promise(((t,o)=>{const i=[],n=http.createServer(((i,n)=>{var a;if(!i.url)return void o(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'));let s;try{s=new URL(i.url,this.redirectUri)}catch(e){return void o(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}const l={code:s.searchParams.get("code"),redirectUri:this.redirectUri,scopes:e,authority:null==r?void 0:r.authority,codeVerifier:null===(a=this.pkceCodes)||void 0===a?void 0:a.verifier};this.acquireTokenByCode(l,null==r?void 0:r.enableCae).then((r=>{(null==r?void 0:r.account)&&(this.account=msalToPublic(this.clientId,r.account));if(r&&r.expiresOn){const o=null==r?void 0:r.expiresOn.valueOf();n.writeHead(200),n.end("Authentication Complete. You can close the browser and return to the application."),this.logger.getToken.info(formatSuccess(e)),t({expiresOnTimestamp:o,token:r.accessToken})}else{const r=formatError(e,`${s.searchParams.get("error")}. ${s.searchParams.get("error_description")}`);n.writeHead(500),n.end(r),this.logger.getToken.info(r),o(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}c()})).catch((()=>{const r=formatError(e,`${s.searchParams.get("error")}. ${s.searchParams.get("error_description")}`);n.writeHead(500),n.end(r),this.logger.getToken.info(r),o(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"')),c()}))})),a=stoppable(n),s=n.listen(this.port,this.hostname,(()=>this.logger.info(`InteractiveBrowserCredential listening on port ${this.port}!`)));function c(){s&&s.close();for(const e of i)e.destroy();a&&(a.close(),a.stop())}n.on("connection",(e=>i.push(e))),n.on("error",(e=>{c();const r=e.code;o(new CredentialUnavailableError("EACCES"===r||"EADDRINUSE"===r?[`InteractiveBrowserCredential: Access denied to port ${this.port}.`,"Try sending a redirect URI with a different port, as follows:",'`new InteractiveBrowserCredential({ redirectUri: "http://localhost:1337" })`'].join(" "):`InteractiveBrowserCredential: Failed to start the necessary web server. Error: ${e.message}`))})),n.on("listening",(()=>{const t=this.openAuthCodeUrl(e,r),i=null==r?void 0:r.abortSignal;i&&i.addEventListener("abort",(()=>{c(),o(new Error("Aborted"))})),t.catch((e=>{c(),o(e)}))}))}))}async openAuthCodeUrl(e,r){const t=new msalNode.CryptoProvider;this.pkceCodes=await t.generatePkceCodes();const o={scopes:e,correlationId:null==r?void 0:r.correlationId,redirectUri:this.redirectUri,authority:null==r?void 0:r.authority,claims:null==r?void 0:r.claims,loginHint:this.loginHint,codeChallenge:this.pkceCodes.challenge,codeChallengeMethod:"S256"},i=await this.getApp("public",null==r?void 0:r.enableCae).getAuthCodeUrl(o);try{await interactiveBrowserMockable.open(i,{wait:!0,newInstance:!0})}catch(e){throw new CredentialUnavailableError(`InteractiveBrowserCredential: Could not open a browser window. Error: ${e.message}`)}}}